Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1319)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -107,99 +113,4 @@
 ! New cpp directive "__check" implemented which is used by check_namelist_files
 !
-! 785 2011-11-28 09:47:19Z raasch
-! +scalar_rayleigh_damping in inipar
-!
-! 767 2011-10-14 06:39:12Z raasch
-! +u_profile, v_profile, uv_heights in inipar
-!
-! 759 2011-09-15 13:58:31Z raasch
-! +maximum_parallel_io_streams in envpar,
-! splitting of parallel I/O in blocks of PEs
-!
-! 683 2011-02-09 14:25:15Z raasch
-! +synchronous_exchange in d3par
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Steering parameter dissipation_control added in inipar. (commented out)
-!
-! 622 2010-12-10 08:08:13Z raasch
-! +collective_wait in inipar
-!
-! 600 2010-11-24 16:10:51Z raasch
-! parameters moved from d3par to inipar: call_psolver_at_all_substeps,
-! cfl_factor, cycle_mg, mg_cycles, mg_switch_to_pe0_level, ngsrb, nsor,
-! omega_sor, prandtl_number, psolver, rayleigh_damping_factor,
-! rayleigh_damping_height, residual_limit
-!
-! 580 2010-10-05 13:59:11Z heinze
-! Renaming of ws_vertical_gradient to subs_vertical_gradient and
-! ws_vertical_gradient_level to subs_vertical_gradient_level
-!
-! 553 2010-09-01 14:09:06Z weinreis
-! parameters for masked output are replaced by arrays
-!
-! 493 2010-03-01 08:30:24Z raasch
-! +netcdf_data_format in d3par, -netcdf_64bit, -netcdf_64bit_3d
-!
-! 449 2010-02-02 11:23:59Z raasch
-! +wall_humidityflux, wall_scalarflux
-! +ws_vertical_gradient, ws_vertical_gradient_level
-!
-! 410 2009-12-04 17:05:40Z letzel
-! masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
-! mask_scale_x|y|z, masks, skip_time_domask
-!
-! 291 2009-04-16 12:07:26Z raasch
-! +local_dvrserver_running in envpar
-! Output of messages replaced by message handling routine.
-! +canyon_height, canyon_width_x, canyon_width_y, canyon_wall_left, 
-! canyon_wall_south, conserve_volume_flow_mode, coupling_start_time,
-! dp_external, dp_level_b, dp_smooth, dpdxy, u_bulk, v_bulk in inipar
-! topography_grid_convention moved from userpar
-!
-! 197 2008-09-16 15:29:03Z raasch
-! +cthf,leaf_surface_concentration, scalar_exchange_coefficient
-! +inflow_damping_height, inflow_damping_width, recycling_width,
-! turbulent_inflow in inipar, -skip_time_dosp in d3par,
-! allocation of hom_sum moved from init_3d_model to here,
-! npex, npey moved from inipar to d3par, setting of myid_char_14 removed,
-! lad is allways allocated
-!
-! 138 2007-11-28 10:03:58Z letzel
-! +canopy_mode, drag_coefficient, lad_surface, lad_vertical_gradient, 
-! lad_vertical_gradient_level, pch_index, plant_canopy, 
-! +allocation of leaf area density field
-!
-! 108 2007-08-24 15:10:38Z letzel
-! +e_init, top_momentumflux_u|v in inipar, +dt_coupling in d3par
-!
-! 95 2007-06-02 16:48:38Z raasch
-! +bc_sa_t, bottom_salinityflux, ocean, sa_surface, sa_vertical_gradient,
-! sa_vertical_gradient_level, top_salinityflux in inipar,
-! sa_init is allocated
-!
-! 87 2007-05-22 15:46:47Z raasch
-! Size of hom increased by the maximum number of user-defined profiles,
-! var_hom renamed pr_palm
-!
-! 82 2007-04-16 15:40:52Z raasch
-! +return_addres, return_username in envpar
-!
-! 75 2007-03-22 09:54:05Z raasch
-! +dt_max, netcdf_64bit_3d, precipitation_amount_interval in d3par,
-! +loop_optimization, pt_reference in inipar, -data_output_ts,
-! moisture renamed humidity
-!
-! 20 2007-02-26 00:12:32Z raasch
-! +top_heatflux, use_top_fluxes in inipar
-!
-! 3 2007-02-13 11:30:58Z raasch
-! +netcdf_64bit_3d in d3par,
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.57  2007/02/11 13:11:22  raasch
-! Values of environment variables are now read from file ENVPAR instead of
-! reading them with a system call, + NAMELIST envpar
-!
 ! Revision 1.1  1997/07/24 11:22:50  raasch
 ! Initial revision
@@ -211,20 +122,111 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE averaging
-    USE cloud_parameters
-    USE control_parameters
-    USE cpulog
-    USE dvrp_variables
-    USE grid_variables
-    USE indices
-    USE model_1d
+    USE arrays_3d,                                                             &
+        ONLY:  lad, pt_init, q_init, ref_state, sa_init, ug, u_init, v_init,   &
+               vg
+
+    USE cloud_parameters,                                                      &
+        ONLY:  c_sedimentation, curvature_solution_effects,                    &
+               limiter_sedimentation, nc_const, ventilation_effect
+
+    USE control_parameters,                                                    &
+        ONLY:  alpha_surface, averaging_interval, averaging_interval_pr,       &
+               bc_e_b, bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t,         &
+               bc_q_b, bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,       &
+               bottom_salinityflux, building_height, building_length_x,        &
+               building_length_y, building_wall_left, building_wall_south,     &
+               call_psolver_at_all_substeps, canopy_mode, canyon_height,       &
+               canyon_width_x, canyon_width_y, canyon_wall_left,               &
+               canyon_wall_south, cfl_factor,                                  &
+               cloud_droplets, cloud_physics, cloud_scheme,                    &
+               conserve_volume_flow, conserve_volume_flow_mode,                &
+               coupling_start_time, create_disturbances, cthf, cycle_mg,       &
+               data_output, data_output_format, data_output_masks,             &
+               data_output_pr, data_output_2d_on_each_pe,                      &
+               disturbance_amplitude, disturbance_energy_limit,                &
+               disturbance_level_b, disturbance_level_t, dissipation_1d,       &
+               do2d_at_begin, do3d_at_begin, do3d_compress, do3d_comp_prec,    &
+               dp_external, dp_level_b, dp_smooth, dpdxy, drag_coefficient,    &
+               drizzle, dt, dz, dt_averaging_input, dt_averaging_input_pr,     &
+               dt_coupling, dt_data_output, dt_data_output_av, dt_disturb,     &
+               dt_domask, dt_dopr, dt_dopr_listing, dt_dots, dt_do2d_xy,       &
+               dt_do2d_xz, dt_do2d_yz, dt_do3d, dt_max, dt_restart,            &
+               dt_run_control, dz_max, dz_stretch_factor, dz_stretch_level,    &
+               end_time, e_init, e_min, fft_method, force_print_header,        &
+               galilei_transformation, host, humidity, inflow_damping_height,  &
+               inflow_damping_width, inflow_disturbance_begin,                 &
+               inflow_disturbance_end,  initializing_actions, io_blocks,       &
+               io_group, km_constant, lad_surface, lad_vertical_gradient,      &
+               lad_vertical_gradient_level, large_scale_forcing,               &
+               large_scale_subsidence, leaf_surface_concentration,             &
+               loop_optimization, masking_method, mask_scale_x, mask_scale_y,  &
+               mask_scale_z, mask_x, mask_y, mask_z, mask_x_loop,              &
+               mask_y_loop, mask_z_loop, maximum_cpu_time_allowed,             &
+               maximum_parallel_io_streams, max_pr_user, message_string,       &
+               mg_cycles, mg_switch_to_pe0_level, mixing_length_1d,            &
+               momentum_advec, netcdf_data_format, netcdf_precision, neutral,  &
+               ngsrb, normalizing_region, nsor, nsor_ini, nudging, ocean,      &
+               omega, omega_sor, passive_scalar, pch_index, phi, nz_do3d,      &
+               plant_canopy, prandtl_layer, prandtl_number, precipitation,     &
+               precipitation_amount_interval, psolver, pt_damping_factor,      &
+               pt_damping_width, pt_reference, pt_surface,                     &
+               pt_surface_initial_change, pt_vertical_gradient,                &
+               pt_vertical_gradient_level, q_surface,                          &
+               q_surface_initial_change, q_vertical_gradient,                  &
+               q_vertical_gradient_level, radiation, random_generator,         &
+               random_heatflux, rayleigh_damping_factor,                       &
+               rayleigh_damping_height, recycling_width, reference_state,      &
+               residual_limit, restart_time, return_addres, return_username,   &
+               revision, rif_max, rif_min, roughness_length, runnr,            &
+               run_identifier, sa_surface, sa_vertical_gradient,               &
+               sa_vertical_gradient_level, scalar_advec,                       &
+               scalar_exchange_coefficient, scalar_rayleigh_damping,           &
+               section_xy, section_xz, section_yz, skip_time_data_output,      &
+               skip_time_data_output_av, skip_time_dopr, skip_time_do2d_xy,    &
+               skip_time_do2d_xz, skip_time_do2d_yz, skip_time_do3d,           &
+               skip_time_domask, subs_vertical_gradient,                       &
+               subs_vertical_gradient_level, surface_heatflux,                 &
+               surface_pressure, surface_scalarflux, surface_waterflux,        &
+               synchronous_exchange,s_surface, s_surface_initial_change,       &
+               s_vertical_gradient, s_vertical_gradient_level,                 &
+               termination_time_needed, timestep_scheme, topography,           &
+               topography_grid_convention, top_heatflux,  top_momentumflux_u,  &
+               top_momentumflux_v, top_salinityflux,                           &
+               transpose_compute_overlap, turbulence, turbulent_inflow,        &
+               ug_surface, ug_vertical_gradient, ug_vertical_gradient_level,   &
+               use_surface_fluxes, use_cmax, use_top_fluxes,                   &
+               use_ug_for_galilei_tr, use_upstream_for_tke, uv_heights,        &
+               u_bulk, u_profile, vg_surface, vg_vertical_gradient,            &
+               vg_vertical_gradient_level, v_bulk, v_profile,                  &
+               wall_adjustment, wall_heatflux, wall_humidityflux,              &
+               wall_scalarflux, write_binary, z0h_factor, z_max_do2d
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log_barrierwait
+
+    USE dvrp_variables,                                                        &
+        ONLY:  local_dvrserver_running
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, ny, nz
+
+    USE model_1d,                                                              &
+        ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
+
     USE pegrid
-    USE profil_parameter
-    USE statistics
+
+    USE profil_parameter,                                                      &
+        ONLY:  cross_profiles, cross_ts_uymax, cross_ts_uymin,                 &
+               profile_columns, profile_rows
+
+    USE statistics,                                                            &
+        ONLY:  hom, hom_sum, pr_palm, region, statistic_regions
 
     IMPLICIT NONE
 
-    INTEGER ::  i
+    INTEGER(iwp) ::  i   !:
 
 
Index: /palm/trunk/SOURCE/plant_canopy_model.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model.f90	(revision 1319)
+++ /palm/trunk/SOURCE/plant_canopy_model.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -28,13 +34,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 257 2009-03-11 15:17:42Z heinze
-! Output of messages replaced by message handling routine.
-! Bugfix: remove IF statement in plant_canopy_model_ij
-!
-! 153 2008-03-19 09:41:30Z steinfeld
-! heat sources within the forest canopy are added, which represent the
-! rate of heat input into the air from the forest leaves, evaluation of sinks
-! and sources for scalar concentration due to canopy elements
 !
 ! 138 2007-11-28 10:03:58Z letzel
@@ -63,12 +60,23 @@
     SUBROUTINE plant_canopy_model( component )
 
-       USE arrays_3d
-       USE control_parameters
-       USE indices
-       USE pegrid
+       USE arrays_3d,                                                          &
+           ONLY:  canopy_heat_flux, cdc, dzw, e, lad_s, lad_u, lad_v, lad_w,   &
+                  q, sec, sls, tend, u, v, w
+
+       USE control_parameters,                                                 &
+           ONLY:  pch_index, message_string
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxlu, nxr, nys, nysv, nyn, nzb_s_inner, nzb_u_inner,    &
+                  nzb_v_inner, nzb_w_inner
+
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  component, i, j, k
+       INTEGER(iwp) ::  component  !:
+       INTEGER(iwp) ::  i          !:
+       INTEGER(iwp) ::  j          !:
+       INTEGER(iwp) ::  k          !:
  
 !
@@ -154,5 +162,5 @@
                 DO  j = nys, nyn
                    DO  k = nzb_s_inner(j,i)+1, pch_index
-                      tend(k,j,i) = tend(k,j,i) +                     &
+                      tend(k,j,i) = tend(k,j,i) +                   &
                                     ( canopy_heat_flux(k,j,i) -     &
                                       canopy_heat_flux(k-1,j,i) ) / &
@@ -221,15 +229,26 @@
     SUBROUTINE plant_canopy_model_ij( i, j, component )
 
-       USE arrays_3d
-       USE control_parameters
-       USE indices
-       USE pegrid
+       USE arrays_3d,                                                          &
+           ONLY:  canopy_heat_flux, cdc, dzw, e, lad_s, lad_u, lad_v, lad_w,   &
+                  q, sec, sls, tend, u, v, w
+
+       USE control_parameters,                                                 &
+           ONLY:  pch_index, message_string
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxlu, nxr, nys, nysv, nyn, nzb_s_inner, nzb_u_inner,    &
+                  nzb_v_inner, nzb_w_inner
+
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  component, i, j, k
-
-!
-!--    Compute drag for the three velocity components 
+       INTEGER(iwp) ::  component  !:
+       INTEGER(iwp) ::  i          !:
+       INTEGER(iwp) ::  j          !:
+       INTEGER(iwp) ::  k          !:
+
+!
+!--    Compute drag for the three velocity components
        SELECT CASE ( component )
 
@@ -238,5 +257,5 @@
        CASE ( 1 )
           DO  k = nzb_u_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                  &
+             tend(k,j,i) = tend(k,j,i) -                     &
                               cdc(k,j,i) * lad_u(k,j,i) *    &   
                               SQRT(     u(k,j,i)**2 +        &
@@ -258,5 +277,5 @@
        CASE ( 2 )
           DO  k = nzb_v_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                  &
+             tend(k,j,i) = tend(k,j,i) -                     &
                               cdc(k,j,i) * lad_v(k,j,i) *    &
                               SQRT( ( ( u(k,j-1,i)   +       &
@@ -278,5 +297,5 @@
        CASE ( 3 )
           DO  k = nzb_w_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                  &
+             tend(k,j,i) = tend(k,j,i) -                     &
                               cdc(k,j,i) * lad_w(k,j,i) *    & 
                               SQRT( ( ( u(k,j,i)    +        &  
@@ -299,5 +318,5 @@
           CASE ( 4 )
              DO  k = nzb_s_inner(j,i)+1, pch_index
-                tend(k,j,i) = tend(k,j,i) +                     &
+                tend(k,j,i) = tend(k,j,i) +                   &
                               ( canopy_heat_flux(k,j,i) -     &
                                 canopy_heat_flux(k-1,j,i) ) / &
@@ -328,5 +347,5 @@
        CASE ( 6 )
           DO  k = nzb_s_inner(j,i)+1, pch_index   
-             tend(k,j,i) = tend(k,j,i) -                     &
+             tend(k,j,i) = tend(k,j,i) -                        &
                               2.0 * cdc(k,j,i) * lad_s(k,j,i) * &
                               SQRT( ( ( u(k,j,i)           +    &
